/*
 * gauger.h
 */

#include <math.h>
#include "seal.h"

#define JOINED				0
#define LEFT				1

#define PTN_PREGEN			1		// pattern paramters
#define PTN_RANDOM			2
#define PTN_MAX_ENTRIES		3000    

#define LEAST_SLEEP_TIME	10		// least time that the user must sleep

#define RUN_TIME			7200	// in sec

typedef struct gauger_control_s * GAUGER_control_p_t;
typedef struct gauger_control_s {
	struct timeval rekey_start_time;
	struct timeval rekey_end_time;
	int no_exp;					// no of exponentiations
	int no_bcast;				// no of blinded key broadcasts
	int no_bkey;				// no of received blinded keys
	int is_checking;			// check if the rekey time being checked

	// Note: I don't declare a lock here since it's only used by the
	// process_thread only
} GAUGER_control_t;

GAUGER_control_p_t GAUGER_init();
void GAUGER_inc_exp(GAUGER_control_p_t gauger);
void GAUGER_inc_bcast(GAUGER_control_p_t gauger);
void GAUGER_inc_bkey(GAUGER_control_p_t gauger, int no_bkey);
void GAUGER_rekey_start_test(GAUGER_control_p_t gauger);
void GAUGER_rekey_end_test(GAUGER_control_p_t gauger, int rekey_seq);
void GAUGER_reset(GAUGER_control_p_t gauger);

SEAL_session_p_t seal_session_g;
GAUGER_control_p_t gauger_g;
