/*
 * process_thread.h
 */

#include "seal.h"

#define REKEY_REBUILD   0x01
#define REKEY_BATCH     0x02
#define REKEY_QSUBTREE  0x03
#define REKEY_QMERGE    0x04

/*** function prototypes ***/

/* init function */
void* PROCESS_init(SEAL_session_p_t);

/* functions of handling membership/regular messages */
void PROCESS_mem_join(int no_curr_guids, char curr_guids[][SEAL_GUID_LEN], 
		char* data);
void PROCESS_mem_leave(int no_curr_guids, char curr_guids[][SEAL_GUID_LEN], 
		char* data);
void PROCESS_reg_rekey(char const* sender, char const* data, int len);
void PROCESS_reg_bkey(char const* sender, char const* data, int len);
void PROCESS_reg_msg(char const* sender, char const* data, int len);

void* PROCESS_cleanup_handler();
